=== pymoab/requirements.txt ===
setuptools
numpy
cython>=0.26
