=== pymoab/pymoab/CMakeLists.txt ===


# create symlinks for all fiels in directory
FILE(GLOB PYMOAB_FILES ${CMAKE_CURRENT_SOURCE_DIR} "*")
IF(NOT ${CMAKE_SOURCE_DIR} MATCHES ${CMAKE_BINARY_DIR})
  FOREACH(PYMOAB_FILE ${PYMOAB_FILES})
    GET_FILENAME_COMPONENT(FILE ${PYMOAB_FILE} NAME)
    EXECUTE_PROCESS(COMMAND ${CMAKE_COMMAND} -E create_symlink ${PYMOAB_FILE} ${CMAKE_CURRENT_BINARY_DIR}/${FILE})
  ENDFOREACH(PYMOAB_FILE)
ENDIF()
